# This file is part of the Coral project.
# Please read the copyright notice in the LICENSE file.

def isDeterministic(self):
    return self.transition.forAll(lambda t1,t2: t1.source!=t2.source or t1.token!=t2.token)

def reverse(self):
    for t in self.transition:
        t.source,t.target=t.target,t.source
